unit mozog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls, ColorBox;

type

  { Tkukacok }

  Tkukacok = class(TForm)
    bkilep: TButton;
    ckukacszin: TColorBox;
    chatterszin: TColorBox;
    Label1: TLabel;
    Label2: TLabel;
    lletszamszaz: TLabel;
    lletszamketszaz: TLabel;
    lletszamnulla: TLabel;
    lsugarnulla: TLabel;
    lsugartizenhat: TLabel;
    lsugar: TLabel;
    rajzlap: TImage;
    tbsugar: TTrackBar;
    tbletszam: TTrackBar;
    Timer1: TTimer;
    procedure kilep(Sender: TObject);
    procedure reset(Sender: TObject);
    procedure rajzol(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;
  kukac=record
     xkor:array[1..25] of integer;
     ykor:array[1..25] of integer;
     ir,kanyar,x,y:real;
     regiveg,farkavege,ujx,ujy:integer;
  end;


const
  letmax=200;

var
  kukacszin, hatterszin: integer;


var
  kukacok: Tkukacok;
  hernyo:array[1..letmax] of kukac;
  index,letszam,code,sugar:integer;
  l:real;



implementation

{$R *.lfm}

{ Tkukacok }

procedure Tkukacok.reset(Sender: TObject);
begin
   kukacszin:=ckukacszin.selected;
   hatterszin:=chatterszin.selected;
   letszam:=TBLetszam.Position;
   rajzlap.Canvas.brush.color:=hatterszin;
   rajzlap.Canvas.pen.color:=kukacszin;
   rajzlap.Canvas.FillRect(rajzlap.ClientRect);
   rajzlap.Canvas.Font.Color:=clWhite;
   rajzlap.Canvas.Font.Size:=16;
   for index:=1 to letszam do with hernyo[index] do begin
      xkor[1]:=400;
      ykor[1]:=400;
      ir:=random(360);
      farkavege:=1;
      sugar:=TBSugar.Position;
   end;
end;

procedure Tkukacok.rajzol(Sender: TObject);
begin
   rajzlap.Canvas.TextOut(8,8,'Kukacok');
   rajzlap.Canvas.brush.color:=hatterszin;
   for index:=1 to letszam do with hernyo[index] do begin
      regiveg:=farkavege;
      farkavege:=farkavege mod 25 + 1;
      rajzlap.Canvas.pen.color:=hatterszin;
      rajzlap.Canvas.ellipse(xkor[farkavege]-sugar,ykor[farkavege]-sugar,xkor[farkavege]+sugar,ykor[farkavege]+sugar);
      kanyar:=random;
      if kanyar<0.5 then ir:=ir+0.1745 else ir:=ir-0.1745;
      x:=xkor[regiveg];
      y:=ykor[regiveg];
      ujx:=trunc(x+sugar*cos(ir));
      ujy:=trunc(y+sugar*sin(ir));
      ujx:=ujx mod 800;
      ujy:=ujy mod 800;
      xkor[farkavege]:=ujx;
      ykor[farkavege]:=ujy;
      rajzlap.Canvas.pen.color:=kukacszin;
      rajzlap.canvas.ellipse(ujx-sugar,ujy-sugar,ujx+sugar,ujy+sugar);
   end;
end;

procedure Tkukacok.kilep(Sender: TObject);
begin
  Close
end;

end.

